<?php

//////////////////////////////////////////////////////////////
//===========================================================
// clone.php
//===========================================================
// SOFTACULOUS 
// Version : 4.2.8
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       10th Jan 2009
// Time:       21:00 hrs
// Site:       http://www.softaculous.com/ (SOFTACULOUS)
// ----------------------------------------------------------
// Please Read the Terms of use at http://www.softaculous.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Inc.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('SOFTACULOUS')){

	die('Hacking Attempt');

}

//The Install process
function __clone(){

global $__settings, $error, $software, $globals, $replace_data, $source_data;
	
	//Do we meet the Minimum software requirements
	__requirements();
	
	if(!empty($error)){
		return false;
	}
	
	$temp = parse_url($source_data['softurl']);
	$source_data['relativeurl'] = $temp['path'];
	
	$temp = parse_url($__settings['softurl']);
	$__settings['relativeurl'] = $temp['path'];
	
	$__settings['blogid'] = 'fp-' . srandstr(8);
	
	$__settings['softpath_'] = $__settings['softpath'];
	
	if($globals['os'] == 'windows'){
		$__settings['softpath_'] = str_replace('/','\\',$__settings['softpath']);
	}
	
	$__settings['fp_hashsalt'] = var_export($__settings['blogid'] . $__settings['softpath_'] . '/' . $__settings['softurl'] . '/' . mt_rand(), true);
	
	//hashsalt.conf.php
	$file = sfile($__settings['softpath'].'/fp-content/config/hashsalt.conf.php');
	
	if(empty($file)){
		$error[] = 'Could not read the config file to get hashsalt value.';
		return false;
	}
	
	soft_preg_replace('/\$fp_hashsalt(\s*?)=(\s*?)(.*?);/is', $file, $fp_hashsalt, 3);
	
	$replace_data[$fp_hashsalt] = $__settings['fp_hashsalt'];
	
	sclone_replace($replace_data, $__settings['softpath'].'/fp-content/config/hashsalt.conf.php', true);

	//settings.conf.php
	$file = sfile($__settings['softpath'].'/fp-content/config/settings.conf.php');
	
	if(empty($file)){
		$error[] = 'Could not read the settings file to get the Blogid and Author name..';
		return false;
	}
	
	soft_preg_replace('/(\'|")blogid(\'|")(\s*?)\=\>(\s*?)(\'|")(.*?)(\'|"),/is', $file, $blogid, 6);
	
	soft_preg_replace('/(\'|")author(\'|")(\s*?)\=\>(\s*?)(\'|")(.*?)(\'|"),/is', $file, $__settings['author'], 6);

	$replace_data[$blogid] = $__settings['blogid'];
	
	sclone_replace($replace_data, $__settings['softpath'].'/fp-content/config/settings.conf.php', true);
	
	//admin.php
	sclone_replace($replace_data, $__settings['softpath'].'/fp-content/users/'.$__settings['author'].'.php', true);

	if(sfile_exists($__settings['softpath'].'/.htaccess')){
	
		// If the installation is on root domain we need to change the below relative URL
		if(is_dom_root($source_data['softpath'])){
			$replace_data['RewriteBase \'/\''] = 'RewriteBase \''.$__settings['relativeurl'].'\'';
			$replace_data['RewriteBase /'] = 'RewriteBase '.$__settings['relativeurl'];
		}elseif(is_dom_root($__settings['softpath'])){
			$replace_data['RewriteBase \''.$source_data['relativeurl'].'\''] = 'RewriteBase \'/\'';
			$replace_data['RewriteBase '.$source_data['relativeurl']] = 'RewriteBase /';
		}
		
		sclone_replace($replace_data, $__settings['softpath'].'/.htaccess', true);		
	}
	
	//recreat cache
	srm($__settings['softpath'].'/fp-content/cache');
	@smkdir($__settings['softpath'].'/fp-content/cache/', $globals['odc']);
	
	// CHMOD
	schmod($__settings['softpath'].'/fp-content/', $globals['odc'], 1);
}

//Check whether the Minimum Software configuration matches
function __requirements(){

global $__settings, $error, $software;
	
	return true;

}

?>